namespace IrisGenerator.Dal {
    using System;
    using System.Collections.Generic;
    using System.Data.SqlClient;
    using System.Configuration;
    using System.Data;
    using System.Xml;
    
    
    public partial class Module : IDisposable {
        
        private DataAccess _dataAccess;
        
        public Module() {
            this._dataAccess = new DataAccess();
        }
        
        public virtual System.Data.DataSet Select_MODULE_By_TAR_ID(System.Nullable<System.Guid> TAR_ID) {
            this._dataAccess.CreateProcedureCommand("sp_Select_MODULE_By_TAR_ID");
            this._dataAccess.AddParameter("TAR_ID", TAR_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet MODULE_Select_All() {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_Select_All");
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet MODULE_Select_One(System.Nullable<System.Guid> MOD_ID) {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_Select_One");
            this._dataAccess.AddParameter("MOD_ID", MOD_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Nullable<System.Guid> MODULE_Insert(System.Nullable<System.Guid> TAR_ID, string MOD_NAME, string MOD_DESCRIPTION, string MOD_ASSEMBLY, string MOD_TYPE) {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_Insert");
            this._dataAccess.AddParameter("TAR_ID", TAR_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_NAME", MOD_NAME, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_DESCRIPTION", MOD_DESCRIPTION, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_ASSEMBLY", MOD_ASSEMBLY, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_TYPE", MOD_TYPE, ParameterDirection.Input);
            Guid value = ((Guid)(this._dataAccess.ExecuteScalar()));
            return value;
        }
        
        public virtual System.Nullable<int> MODULE_Delete(System.Nullable<System.Guid> MOD_ID) {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_Delete");
            this._dataAccess.AddParameter("MOD_ID", MOD_ID, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual System.Nullable<int> MODULE_Update(System.Nullable<System.Guid> MOD_ID, System.Nullable<System.Guid> TAR_ID, string MOD_NAME, string MOD_DESCRIPTION, string MOD_ASSEMBLY, string MOD_TYPE) {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_Update");
            this._dataAccess.AddParameter("MOD_ID", MOD_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("TAR_ID", TAR_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_NAME", MOD_NAME, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_DESCRIPTION", MOD_DESCRIPTION, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_ASSEMBLY", MOD_ASSEMBLY, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_TYPE", MOD_TYPE, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual void Dispose() {
            if ((this._dataAccess != null)) {
                this._dataAccess.Dispose();
            }
        }
    }
}
