namespace IrisGenerator.Dal {
    using System;
    using System.Collections.Generic;
    using System.Data.SqlClient;
    using System.Configuration;
    using System.Data;
    using System.Xml;
    
    
    public partial class ModuleInstance : IDisposable {
        
        private DataAccess _dataAccess;
        
        public ModuleInstance() {
            this._dataAccess = new DataAccess();
        }
        
        public virtual System.Data.DataSet Select_MODULE_INSTANCE_By_FOR_ID(System.Nullable<System.Guid> FOR_ID) {
            this._dataAccess.CreateProcedureCommand("sp_Select_MODULE_INSTANCE_By_FOR_ID");
            this._dataAccess.AddParameter("FOR_ID", FOR_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet Select_MODULE_INSTANCE_By_MOD_ID(System.Nullable<System.Guid> MOD_ID) {
            this._dataAccess.CreateProcedureCommand("sp_Select_MODULE_INSTANCE_By_MOD_ID");
            this._dataAccess.AddParameter("MOD_ID", MOD_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet Select_MODULE_INSTANCE_By_PRO_ID(System.Nullable<System.Guid> PRO_ID) {
            this._dataAccess.CreateProcedureCommand("sp_Select_MODULE_INSTANCE_By_PRO_ID");
            this._dataAccess.AddParameter("PRO_ID", PRO_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet MODULE_INSTANCE_Select_All() {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_INSTANCE_Select_All");
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet MODULE_INSTANCE_Select_One(System.Nullable<System.Guid> MOD_INS_ID) {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_INSTANCE_Select_One");
            this._dataAccess.AddParameter("MOD_INS_ID", MOD_INS_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Nullable<System.Guid> MODULE_INSTANCE_Insert(System.Nullable<System.Guid> MOD_ID, System.Nullable<System.Guid> FOR_ID, System.Nullable<System.Guid> PRO_ID, System.Nullable<bool> MOD_INS_GENERATE, System.Nullable<bool> MOD_INS_ANALYZE) {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_INSTANCE_Insert");
            this._dataAccess.AddParameter("MOD_ID", MOD_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("FOR_ID", FOR_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("PRO_ID", PRO_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_INS_GENERATE", MOD_INS_GENERATE, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_INS_ANALYZE", MOD_INS_ANALYZE, ParameterDirection.Input);
            Guid value = ((Guid)(this._dataAccess.ExecuteScalar()));
            return value;
        }
        
        public virtual System.Nullable<int> MODULE_INSTANCE_Delete(System.Nullable<System.Guid> MOD_INS_ID) {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_INSTANCE_Delete");
            this._dataAccess.AddParameter("MOD_INS_ID", MOD_INS_ID, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual System.Nullable<int> MODULE_INSTANCE_Update(System.Nullable<System.Guid> MOD_INS_ID, System.Nullable<System.Guid> MOD_ID, System.Nullable<System.Guid> FOR_ID, System.Nullable<System.Guid> PRO_ID, System.Nullable<bool> MOD_INS_GENERATE, System.Nullable<bool> MOD_INS_ANALYZE) {
            this._dataAccess.CreateProcedureCommand("sp_MODULE_INSTANCE_Update");
            this._dataAccess.AddParameter("MOD_INS_ID", MOD_INS_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_ID", MOD_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("FOR_ID", FOR_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("PRO_ID", PRO_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_INS_GENERATE", MOD_INS_GENERATE, ParameterDirection.Input);
            this._dataAccess.AddParameter("MOD_INS_ANALYZE", MOD_INS_ANALYZE, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual void Dispose() {
            if ((this._dataAccess != null)) {
                this._dataAccess.Dispose();
            }
        }
    }
}
