namespace IrisGenerator.Dal {
    using System;
    using System.Collections.Generic;
    using System.Data.SqlClient;
    using System.Configuration;
    using System.Data;
    using System.Xml;
    
    
    public partial class Target : IDisposable {
        
        private DataAccess _dataAccess;
        
        public Target() {
            this._dataAccess = new DataAccess();
        }
        
        public virtual System.Data.DataSet TARGET_Select_All() {
            this._dataAccess.CreateProcedureCommand("sp_TARGET_Select_All");
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet TARGET_Select_One(System.Nullable<System.Guid> TAR_ID) {
            this._dataAccess.CreateProcedureCommand("sp_TARGET_Select_One");
            this._dataAccess.AddParameter("TAR_ID", TAR_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Nullable<System.Guid> TARGET_Insert(string TAR_CODE, string TAR_DESCRIPTION) {
            this._dataAccess.CreateProcedureCommand("sp_TARGET_Insert");
            this._dataAccess.AddParameter("TAR_CODE", TAR_CODE, ParameterDirection.Input);
            this._dataAccess.AddParameter("TAR_DESCRIPTION", TAR_DESCRIPTION, ParameterDirection.Input);
            Guid value = ((Guid)(this._dataAccess.ExecuteScalar()));
            return value;
        }
        
        public virtual System.Nullable<int> TARGET_Delete(System.Nullable<System.Guid> TAR_ID) {
            this._dataAccess.CreateProcedureCommand("sp_TARGET_Delete");
            this._dataAccess.AddParameter("TAR_ID", TAR_ID, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual System.Nullable<int> TARGET_Update(System.Nullable<System.Guid> TAR_ID, string TAR_CODE, string TAR_DESCRIPTION) {
            this._dataAccess.CreateProcedureCommand("sp_TARGET_Update");
            this._dataAccess.AddParameter("TAR_ID", TAR_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("TAR_CODE", TAR_CODE, ParameterDirection.Input);
            this._dataAccess.AddParameter("TAR_DESCRIPTION", TAR_DESCRIPTION, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual void Dispose() {
            if ((this._dataAccess != null)) {
                this._dataAccess.Dispose();
            }
        }
    }
}
