namespace IrisGenerator.Common.DatabaseModel.DataAccess
{
    using System;
    using System.Collections.Generic;
    using System.Data.SqlClient;
    using System.Configuration;
    using System.Data;
    using System.Xml;
    using IrisGenerator.Dal;
    
    
    public partial class RequestParameter : IDisposable {
        
        private DataAccess _dataAccess;
        
        public RequestParameter() {
            this._dataAccess = new DataAccess();
        }
        
        public virtual System.Data.DataSet Select_REQUEST_PARAMETER_By_COL_ID(System.Nullable<System.Guid> COL_ID) {
            this._dataAccess.CreateProcedureCommand("sp_Select_REQUEST_PARAMETER_By_COL_ID");
            this._dataAccess.AddParameter("COL_ID", COL_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet Select_REQUEST_PARAMETER_By_MET_ID(System.Nullable<System.Guid> MET_ID) {
            this._dataAccess.CreateProcedureCommand("sp_Select_REQUEST_PARAMETER_By_MET_ID");
            this._dataAccess.AddParameter("MET_ID", MET_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet Select_REQUEST_PARAMETER_By_REQ_ID(System.Nullable<System.Guid> REQ_ID) {
            this._dataAccess.CreateProcedureCommand("sp_Select_REQUEST_PARAMETERs_By_REQ_ID");
            this._dataAccess.AddParameter("REQ_ID", REQ_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet REQUEST_PARAMETER_Select_All() {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_PARAMETER_Select_All");
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet REQUEST_PARAMETER_Select_One(System.Nullable<System.Guid> REQ_PAR_ID) {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_PARAMETER_Select_One");
            this._dataAccess.AddParameter("REQ_PAR_ID", REQ_PAR_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Nullable<System.Guid> REQUEST_PARAMETER_Insert(System.Nullable<System.Guid> MET_ID, System.Nullable<System.Guid> REQ_ID, System.Nullable<System.Guid> COL_ID, string REQ_PAR_NAME, string REQ_PAR_LENGTH, System.Nullable<int> REQ_PAR_PRECISION, System.Nullable<int> REQ_PAR_DIRECTION, string REQ_PAR_FORMATED_NAME) {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_PARAMETER_Insert");
            this._dataAccess.AddParameter("MET_ID", MET_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_ID", REQ_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("COL_ID", COL_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_NAME", REQ_PAR_NAME, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_LENGTH", REQ_PAR_LENGTH, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_PRECISION", REQ_PAR_PRECISION, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_DIRECTION", REQ_PAR_DIRECTION, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_FORMATED_NAME", REQ_PAR_FORMATED_NAME, ParameterDirection.Input);
            Guid value = ((Guid)(this._dataAccess.ExecuteScalar()));
            return value;
        }
        
        public virtual System.Nullable<int> REQUEST_PARAMETER_Delete(System.Nullable<System.Guid> REQ_PAR_ID) {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_PARAMETER_Delete");
            this._dataAccess.AddParameter("REQ_PAR_ID", REQ_PAR_ID, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual System.Nullable<int> REQUEST_PARAMETER_Update(System.Nullable<System.Guid> REQ_PAR_ID, System.Nullable<System.Guid> MET_ID, System.Nullable<System.Guid> REQ_ID, System.Nullable<System.Guid> COL_ID, string REQ_PAR_NAME, string REQ_PAR_LENGTH, System.Nullable<int> REQ_PAR_PRECISION, System.Nullable<int> REQ_PAR_DIRECTION, string REQ_PAR_FORMATED_NAME) {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_PARAMETER_Update");
            this._dataAccess.AddParameter("REQ_PAR_ID", REQ_PAR_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("MET_ID", MET_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_ID", REQ_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("COL_ID", COL_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_NAME", REQ_PAR_NAME, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_LENGTH", REQ_PAR_LENGTH, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_PRECISION", REQ_PAR_PRECISION, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_DIRECTION", REQ_PAR_DIRECTION, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_PAR_FORMATED_NAME", REQ_PAR_FORMATED_NAME, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual void Dispose() {
            if ((this._dataAccess != null)) {
                this._dataAccess.Dispose();
            }
        }
    }
}
