namespace IrisGenerator.Common.DatabaseModel.DataAccess
{
    using System;
    using System.Collections.Generic;
    using System.Data.SqlClient;
    using System.Configuration;
    using System.Data;
    using System.Xml;
    using IrisGenerator.Dal;
    
    
    public partial class RequestType : IDisposable {
        
        private DataAccess _dataAccess;
        
        public RequestType() {
            this._dataAccess = new DataAccess();
        }
        
        public virtual System.Data.DataSet REQUEST_TYPE_Select_All() {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_TYPE_Select_All");
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Data.DataSet REQUEST_TYPE_Select_One(System.Nullable<System.Guid> REQ_TYP_ID) {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_TYPE_Select_One");
            this._dataAccess.AddParameter("REQ_TYP_ID", REQ_TYP_ID, ParameterDirection.Input);
            DataSet value = this._dataAccess.ExecuteDataSet();
            return value;
        }
        
        public virtual System.Nullable<System.Guid> REQUEST_TYPE_Insert(string REQ_TYP_CODE, string REQ_TYP_DESCRIPTION) {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_TYPE_Insert");
            this._dataAccess.AddParameter("REQ_TYP_CODE", REQ_TYP_CODE, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_TYP_DESCRIPTION", REQ_TYP_DESCRIPTION, ParameterDirection.Input);
            Guid value = ((Guid)(this._dataAccess.ExecuteScalar()));
            return value;
        }
        
        public virtual System.Nullable<int> REQUEST_TYPE_Delete(System.Nullable<System.Guid> REQ_TYP_ID) {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_TYPE_Delete");
            this._dataAccess.AddParameter("REQ_TYP_ID", REQ_TYP_ID, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual System.Nullable<int> REQUEST_TYPE_Update(System.Nullable<System.Guid> REQ_TYP_ID, string REQ_TYP_CODE, string REQ_TYP_DESCRIPTION) {
            this._dataAccess.CreateProcedureCommand("sp_REQUEST_TYPE_Update");
            this._dataAccess.AddParameter("REQ_TYP_ID", REQ_TYP_ID, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_TYP_CODE", REQ_TYP_CODE, ParameterDirection.Input);
            this._dataAccess.AddParameter("REQ_TYP_DESCRIPTION", REQ_TYP_DESCRIPTION, ParameterDirection.Input);
            int value = this._dataAccess.ExecuteNonQuery();
            return value;
        }
        
        public virtual void Dispose() {
            if ((this._dataAccess != null)) {
                this._dataAccess.Dispose();
            }
        }
    }
}
