﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace IrisGenerator.Framework.Messaging
{
    public class Message
    {
        public MessageResults Result { get; set; }
        public string Content { get; set; }
        public string Caption { get; set; }
        public MessageButtons Buttons { get; set; }
        public MessageIcon Icon { get; set; }
        public MessageDefaultButton DefaultButton { get; set; }

        public Message(string message, string caption)
        {
            this.Content = message;
            this.Caption = caption;
            this.Buttons = MessageButtons.Ok;
            this.Icon = MessageIcon.None;
            this.DefaultButton = MessageDefaultButton.Button1;
        }

        public Message(string message, string caption, MessageButtons buttons, MessageIcon icon, MessageDefaultButton defaultButton)
        {
            this.Content = message;
            this.Caption = caption;
            this.Buttons = buttons;
            this.Icon = icon;
            this.DefaultButton = defaultButton;
        }

    }
}
